#include "MyMenuBar.h"

MyMenuItem::MyMenuItem(QString text,int what)
{
  switch (what)
    {
    case 0:
      sub_menu=FALSE;
      separator=FALSE;
      break;
    case 1:
      sub_menu=TRUE;
      separator=FALSE;
      break;
    case 2:
      sub_menu=FALSE;
      separator=TRUE;
      break;
    }
  label=text;
  is_cb=FALSE;
  on=FALSE;
  keys=NULL;
}

void MyMenuItem::setCB(bool val)
{
  is_cb=val;
}

void MyMenuItem::setState(bool val)
{
  on=val;
}

bool MyMenuItem::isCB()
{
  return is_cb;
}

bool MyMenuItem::getState()
{
  return on;
}
int MyMenuItem::getShc()
{
  return shc;
}
int MyMenuItem::getMod()
{
  return mod;
}

MyMenu::MyMenu(const char *text, QWidget *parent, const char *name):QLabel(text,parent,name)
{
  father=(MyMenuBar *)parent;
  help=FALSE;
  sem=FALSE;
}


void MyMenu::semOp()
{
  if(sem)
    emit noEnter();
  else
    sem=TRUE;
}

void MyMenu::semDown()
{
  sem=FALSE;
}


MyMenuBar::MyMenuBar(QWidget *parent,const char *name): QPushButton(parent,name)
{
  sem=FALSE;
}

void MyMenuBar::semOp()
{
  if(sem)
    emit noEnter();
  else
    sem=TRUE;
}

void MyMenuBar::semDown()
{
  sem=FALSE;
}

void MyMenuBar::addMenu(MyMenu *widget)
{
  MyMenu *tmp;

  if((!menus.isEmpty())&&(!menus.last()->help))
    widget->move(menus.last()->x()+menus.last()->width()+5,2);
  else
    widget->move(0,2);
  widget->resize(40,height()-4);
  widget->setAlignment(AlignCenter);
  widget->show();
  menus.append(widget);
}

void MyMenuBar::rmMenu(MyMenu *val)
{
  MyMenu *tmp;
  int x=0;

  menus.remove(val);
  menus.first();
  while((tmp=menus.next())!=NULL)
  {
    tmp->move(x,2);
    x+=tmp->width()+5;
  }
}

void MyMenuBar::adjust()
{ 
  MyMenu *tmp;
  int i,x=0;
  
  tmp=menus.first();
  i=-1;
  do
    {
      tmp->resize((tmp->sizeHint()).width()+10,tmp->height());
      if(tmp->help)
	{
	  if(i<0)
	    {
	      tmp->move(width()-tmp->width(),2);
	      i=menus.find(tmp);
	    }
	  else
	    {
	      tmp->help=FALSE;
	      tmp->move(x,2);
	      x+=tmp->width()+5;
	    }
	}
      else
	{
	  tmp->move(x,2);
	  x+=tmp->width()+5;
	}
    }
  while((tmp=menus.next())!=NULL);  
  if(i>0)
    {
      tmp=menus.at(i);
      menus.remove(i);
      menus.insert(0,tmp);
    }
}




